      program aesioc4bz
C........................................................................Aug. 2015
C Add selection of t0 by B, dB/dt and Bz
C
C Add SW speed, Vocp, Vocn in output file 
C......................................................Apr. 2015
C AE and AE proxy storms for 1999-2015
C
C.......................................................Mar. 2013
C Select vnjoc & vpjoc for 12 hrs prior AEstorm peak, and 35 hrs after AEs peak =48 hrs

C.......................................................Mar. 2009
C 
C Input AEstart (min of AE): yr,mn,dy,UT storm start; 
C
C
C Input AEstorm2.txt = 92 storms for 1999-2013	
C
C
C 1) Select periods of AE storms (hour by hour UT)
C
C 2) Combine arrays during AE storms (1) AE data; (2) AEs (3) AEs/AEspeak
C 
C
c AE and AEs collected for UT: 0, 1, ...,23 hrs
c
	DIMENSION im(12),dst(0:23),xsw(0:23),xvp(0:23),xvn(0:23)
	+,bom(0:23),bz(0:23),pd(0:23) ! from OMNI monthly files
	+,aedat(95),iaes(48,95),isw(48,95),ivp(48,95),ivn(48,95)
	+,aes(0:95),asw(0:95),avp(0:95),avn(0:95)  ! 4 days UT data
	+,abom(0:95),abz(0:95),apd(0:95) ! from OMNI monthly files
C=	+,spd(0:95)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64 outfile,infileb1 !aeYEARs
	+,infildst,infilesw,infilepm,infilenm,infilebz
	CHARACTER*4 AYEAR
      CHARACTER*2 AYR,AMN,ADY,AMN1,AMN2,AMN3
	CHARACTER*2 AUT,DYR,DMN,DMN1,DMN2,DMN3,DDY,DDY1,DDY2,DDY3,XUT
	+,wyr(95),wmn(95),wdy(95),wut(95)
		CHARACTER*128 title
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

      outfile='aesioc4bz.txt' ! for AEstorm2.txt input 
C
	OPEN(112,FILE=OUTFILE,ACCESS='APPEND')

C start = Enter AEs storms Catalog

C% AE proxy storms and substorms; AE smoothed 7 h peak >=900. nT
C    1 AE 9902*18  2  AE 9902*18 11   940.  AE 9902*19 17   40

	infildst='AEstorm2.txt'
  801	format(A64)
  802	format(24X,2(A2),1X,A2,1X,I2,2X,F5.0)     ! NEW READING Peak OF AEs STORM
	OPEN(10,FILE=infildst,ACTION='READ')
	read(10,801) title
	jend=0
	DO j=1,95
	read(10,802,end=800) wyr(j),wmn(j),wdy(j),iut,aedat(j) !Peak of AEs storm
	jend=jend+1
	call blet2(iut,AUT)
	wut(j)=aut
	enddo
  800	close (unit=10)
  305	format(2(1X,I4),1X,F6.0)
C ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Cycle on AEs storms
      nst1=0	
C
  805	DO 870 nn=1,jend
C
	adst=aedat(nn)
C 
	jj=0 ! count successive UT records
	nst1=nst1+1
	write(*,305) nst1,nn,adst
	write(112,305) nst1,nn,adst
	do j=0,95	 ! 
	asw(j)=0.
	aes(j)=0.
	avp(j)=0.
	avn(j)=0.
	enddo
C
	ayr=wyr(nn)
 	read(ayr,*) ryr
	jyr=int(ryr)
	amn=wmn(nn)
 	read(amn,*) rmn
	jmn=int(rmn)
	ady=wdy(nn)
 	read(ady,*) rdy
	jdy=int(rdy)
	lda=ndoy(jyr,jmn,jdy)
	lda1=lda-1
C	if (lda1.le.0) then
C	lda1=lda
C	endif
	lda2=lda+1
	lda3=lda2+1
	call submmdd(lda1,jyr,jmn1,jdy1) 
	call submmdd(lda2,jyr,jmn2,jdy2) 
	call submmdd(lda3,jyr,jmn3,jdy3) 
	call blet2(jmn1,AMN1)
	call blet2(jmn2,AMN2)
	call blet2(jmn3,AMN3)

	xut=wut(nn)
 	read(xut,*) rut
	jut=int(rut)
	jut1=jut
	jut2=jut

C
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
  	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
  196	format(A12)
  195	format(A128)
C
  809	continue
C Open AE file to select AE
  	infileb1='d:/Apkp/ae/aeYEARs'		 !
	INFILESW='d:/Apkp/OMNI/swYEAR'
 	INFILEPM='c:/msdev/projects/counts/pmtocYR.txt'
	INFILENM='c:/msdev/projects/counts/nmtocYR.txt'
	INFILEBZ='d:/Apkp/OMNI/swYEARMN.txt'

	AYEAR(3:4)=AYR
	if (jyr.gt.19) then
	AYEAR(1:2)='19'
	                 else
	AYEAR(1:2)='20'
	endif
	infileb1(14:17)=AYEAR
	infilesw(16:19)=AYEAR
	infilepm(31:32)=AYR
	infilenm(31:32)=AYR
	infilebz(16:19)=AYEAR
      OPEN(34,FILE=infileb1,ACTION='READ')		!AEYEAR file
	OPEN(35,FILE=infilesw,ACTION='READ')		!SW speed file
	OPEN(36,FILE=infilepm,ACTION='READ')		!Vpos file 'clouds'%*100
	read(36,801) title
	OPEN(37,FILE=infilenm,ACTION='READ')		!Vneg file 'trough'%*100
	read(37,801) title
C
  193 format(I4,1X,I3,1X,I2,3(1X,F5.1))
C Data for prec day:
      infilebz(20:21)=AMN1  ! Prec. mn
	OPEN(33,FILE=infilebz,ACTION='READ')		!OMNI file for prec. month
	do k=1,12
	read(33,195) title	  ! extra lines
	enddo
	DO kdy=1,jdy1
	do kut=0,23
	READ(33,193,END=854) NYEAR,nda1,nut1,bom(kut),bz(kut),pd(kut) !for prec day
	abom(kut)=bom(kut)
	abz(kut)=bz(kut)
	apd(kut)=pd(kut)
	enddo
	ENDDO
  854	close(unit=33)
C
C Data for curr day:
      infilebz(20:21)=AMN  ! Curr. mn
	OPEN(33,FILE=infilebz,ACTION='READ')		!OMNI file for curr month
	do k=1,12
	read(33,195) title	  ! extra lines
	enddo
	DO kdy=1,jdy
	do kut=0,23
	READ(33,193,END=853) NYEAR,nda0,nut0,bom(kut),bz(kut),pd(kut) !for curr day
	abom(kut+24)=bom(kut)
	abz(kut+24)=bz(kut)
	apd(kut+24)=pd(kut)
	enddo
	ENDDO
  853	close(unit=33)

C Data for Next_1 day:
      infilebz(20:21)=AMN2  ! MN for Next_1 day
	OPEN(33,FILE=infilebz,ACTION='READ')	!OMNI  month file for Next_1 day
	do k=1,12
	read(33,195) title	  ! extra lines
	enddo
	DO kdy=1,jdy2
	do kut=0,23
	READ(33,193,END=852) NYEAR,nda0,nut0,bom(kut),bz(kut),pd(kut) !for Next_1 day
	abom(kut+48)=bom(kut)  !   Next_1  day
	abz(kut+48)=bz(kut)
	apd(kut+48)=pd(kut)
	enddo
	ENDDO
  852	close(unit=33)

C Data for Next_2 day:
      infilebz(20:21)=AMN3  ! MN for Next_2 days
	OPEN(33,FILE=infilebz,ACTION='READ')	!OMNI  month file for Next_2 day
	do k=1,12
	read(33,195) title	  ! extra lines
	enddo
	DO kdy=1,jdy3
	do kut=0,23
	READ(33,193,END=851) NYEAR,nda0,nut0,bom(kut),bz(kut),pd(kut) !for Next_2 day
	abom(kut+72)=bom(kut)   !   Next_2  day
	abz(kut+72)=bz(kut)
	apd(kut+72)=pd(kut)
	enddo
	ENDDO
  851	close(unit=33)

C Data for prec day:

	do id=1,lda1
	READ(34, 197, END=855) DYR,DMN1,DDY1,(DST(k),k=0,23) ! 
	READ(35, 198, END=855) DYR,DMN1,DDY1,(xsw(k),k=0,23) ! 
	READ(36, 199, END=855) DYR,DMN1,DDY1,(xvp(k),k=0,23) ! 
	READ(37, 199, END=855) DYR,DMN1,DDY1,(xvn(k),k=0,23) ! 
	enddo
  197 format(3X,2A2,1X,A2,10X,24(F4.0))
  198 format(1X,3A2,24(1X,F4.0))
  199 format(3A2,24(1X,F4.2))
	do j=0,23
	aes(j)=dst(j)  ! prec. day
	asw(j)=xsw(j)  ! prec. day
	avp(j)=xvp(j)  ! prec. day
	avn(j)=xvn(j)  ! prec. day
	enddo
  855 CONTINUE

C Data for curr day:

  	READ(34, 197, END=1855) DYR,DMN,DDY,(DST(k),k=0,23) ! current day
	READ(35, 198, END=1855) DYR,DMN,DDY,(xsw(k),k=0,23) ! 
	READ(36, 199, END=1855) DYR,DMN,DDY,(xvp(k),k=0,23) ! 
	READ(37, 199, END=1855) DYR,DMN,DDY,(xvn(k),k=0,23) ! 
	do j=0,23
	aes(j+24)=dst(j)  ! curr. day
	asw(j+24)=xsw(j)  ! 
	avp(j+24)=xvp(j)  ! 
	avn(j+24)=xvn(j)  ! 
	enddo
 1855 CONTINUE

C Data for next_1 day:

	READ(34, 197, END=2855) DYR,DMN2,DDY2,(DST(k),k=0,23) ! next_1 day
	READ(35, 198, END=2855) DYR,DMN2,DDY2,(xsw(k),k=0,23) ! 
	READ(36, 199, END=2855) DYR,DMN2,DDY2,(xvp(k),k=0,23) ! 
	READ(37, 199, END=2855) DYR,DMN2,DDY2,(xvn(k),k=0,23) ! 
	do j=0,23
	aes(j+48)=dst(j)  ! next_1 day
	asw(j+48)=xsw(j)  ! 
	avp(j+48)=xvp(j)  ! 
	avn(j+48)=xvn(j)  ! 
	enddo
 2855 CONTINUE

C Data for next_2 day:

	READ(34, 197, END=3855) DYR,DMN3,DDY3,(DST(k),k=0,23) ! next_2 day
	READ(35, 198, END=3855) DYR,DMN3,DDY3,(xsw(k),k=0,23) ! 
	READ(36, 199, END=3855) DYR,DMN3,DDY3,(xvp(k),k=0,23) ! 
	READ(37, 199, END=3855) DYR,DMN3,DDY3,(xvn(k),k=0,23) ! 
	do j=0,23
	aes(j+72)=dst(j)  ! next_2 day
	asw(j+72)=xsw(j)  ! 
	avp(j+72)=xvp(j)  ! 
	avn(j+72)=xvn(j)  ! 
	enddo
 3855 CONTINUE
	close(unit=34)
	close(unit=35)
	close(unit=36)
	close(unit=37)
C

C
  194 format(3A2,24(1X,I4))

C Select to=jut1 from jut-12 to jut-1:
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	jutstart=24+jut-12
	jutpre=jutstart+11
	jut1=24+jut-12
C
	DO 850 kk=jutstart,jutpre
	if (abz(kk).gt.990.) goto 849
	if (abz(kk).le.-10.) then
	jut1=kk
	exit
	endif

  849	if (abom(kk).gt.990.) goto 850
      if (kk.gt.0) then
	dbdt=abom(kk)-abom(kk-1)
	if (dbdt.ge.3.) then
	jut1=kk
	exit
	endif
	endif

	if (kk.ge.2) then
	bb=abom(kk)-abom(kk-2)
	if (bb.ge.5.0) then
	jut1=kk
	exit
	endif
	endif
  850	CONTINUE
c
	jut2=jut1+47
C
C?	jres=jut1-6 !???????
	kk=0
	DO jout=jut1,jut2
	kk=kk+1
	aesut=aes(jout)
	aswut=asw(jout)
	avput=avp(jout)
	avnut=avn(jout)
	abomut=abom(jout)
	abzut=abz(jout)
	apdut=apd(jout)
      isw(kk,nn)=int(aswut)
      iaes(kk,nn)=int(aesut)
	 ivp(kk,nn)=int(avput*100.)
	ivn(kk,nn)=int(avnut*100.)
	jres=jout-24
C-	jres=jres+1
	if (jres.lt.0) jres=jres+24
	if (jres.gt.23) jres=jres-24
	if (jres.gt.23) jres=jres-24
	if (jres.gt.23) jres=jres-24
	call blet2(jres,AUT)
C
	amn=dmn
	ady=ddy
	if (jout.lt.24) then
	amn=dmn1
	ady=ddy1
	 endif
	if ((jout.ge.24).and.(jout.le.47)) then
	amn=dmn
	ady=ddy
	 endif
	if ((jout.ge.48).and.(jout.le.71)) then
	amn=dmn2
	ady=ddy2
	 endif
	if (jout.ge.72) then
	amn=dmn3
	ady=ddy3
	 endif
	write(*,272) AYR,AMN,ADY,aut,aesut,aswut,avput,avnut
	+,abomut,abzut,apdut
	write(112,272) AYR,AMN,ADY,aut,aesut,aswut,avput,avnut
	+,abomut,abzut,apdut
	ENDDO
C
C 
C851	 CONTINUE	   ! END of CYCLE ON EVENT
C	close(unit=34)
C	close(unit=35)
  870	continue			 ! next event
270   format(72(1X,I4))  
   71	format(A64)
   82	format(2A2,I2,24(1X,I4))
  273   format(48(1X,I4))
  274   format(48(1X,F5.2))
  272   format(1X,3A2,1X,A2,2(1X,F5.0),2(1X,F6.2),3(1X,F5.1))

	write(112,*) ' AEs '
      do kk=1,95
	write(*,273) (iaes(k,kk),k=1,48)
	write(112,273) (iaes(k,kk),k=1,48)
	enddo
	write(112,*) ' SW'
      do kk=1,95
	write(*,273) (isw(k,kk),k=1,48)
	write(112,273) (isw(k,kk),k=1,48)
	enddo
	write(112,*) ' Vpos'
      do kk=1,95
	write(*,273) (ivp(k,kk),k=1,48)
	write(112,273) (ivp(k,kk),k=1,48)
	enddo
	write(112,*) ' Vneg'
      do kk=1,95
	write(*,273) (ivn(k,kk),k=1,48)
	write(112,273) (ivn(k,kk),k=1,48)
	enddo
		CLOSE(unit=112)
	goto 900                ! 
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 continue
      pause ' '
      STOP
      END


C ====================================================================
